package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.AsesmenGiziAwal;

import com.jasamedika.medifirst2000.vo.AsesmenGiziAwalVO;

@Component
public class AsesmenGiziAwalConverter implements BaseVoConverter<AsesmenGiziAwalVO, AsesmenGiziAwal> {


	@Override
	public AsesmenGiziAwal transferVOToModel(AsesmenGiziAwalVO vo, AsesmenGiziAwal model) {
		if (null == model)
			model = new AsesmenGiziAwal();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, AsesmenGiziAwal.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<AsesmenGiziAwalVO> transferListOfModelToListOfVO(List<AsesmenGiziAwal> models, List<AsesmenGiziAwalVO> vos) {

		if (null == vos)
			vos = new ArrayList<AsesmenGiziAwalVO>();

		if (null == models)
			return vos;

		for (AsesmenGiziAwal asesmenGiziAwal : models) {
			AsesmenGiziAwalVO vo = new AsesmenGiziAwalVO();
			vo=transferModelToVO(asesmenGiziAwal, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public AsesmenGiziAwalVO transferModelToVO(AsesmenGiziAwal model, AsesmenGiziAwalVO vo) {
		if (null == vo)
			vo = new AsesmenGiziAwalVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, AsesmenGiziAwalVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	public AsesmenGiziAwalVO transferModelToVOCustom(AsesmenGiziAwal model, AsesmenGiziAwalVO vo,String[] fieldsToInclude) {
		if (null == vo)

		vo = new AsesmenGiziAwalVO();

		try {
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, AsesmenGiziAwalVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
	
	
	

}
